package cn.rankin.productservice.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Data
@ToString
@Table(name = "lj_item_tag_relation", uniqueConstraints = {@UniqueConstraint(columnNames = {"item_id", "tag_id"})},
        indexes = {@Index(columnList = "item_id"), @Index(columnList = "tag_id")})
@Entity
@DynamicUpdate
@DynamicInsert
public class ItemTagRelation implements Serializable {

    @Id
    private String id;

    @Column(name = "item_id")
    private String itemId;

    @Column(name = "tag_id")
    private String tagId;

    @Column
    private Integer sort;

    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;
}
