package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.productservice.entity.SupportSelfRelation;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import javax.transaction.Transactional;
import java.util.List;

public interface SupportSelfRelationRepository extends BasicJpaRepository<SupportSelfRelation, String> {

    @Query(value = "select r from SupportSelfRelation r where r.fid = :fid and r.status = :status order by r.sort")
    List<SupportSelfRelation> findByFid(@Param("fid") String fid, @Param("status") BaseStatusEnum status);

    List<SupportSelfRelation> findAllByFid(String fid);

    @Transactional
    @Modifying(clearAutomatically = true)
    @Query(value = "update SupportSelfRelation r set r.status = :status where r.fid = :fid")
    Integer deleteByFid(@Param("fid") String fid, @Param("status")BaseStatusEnum status);

}
