package cn.rankin.productservice.utils;

import cn.rankin.common.utils.dto.product.*;
import cn.rankin.common.utils.enums.CourseSubTypeEnum;
import cn.rankin.productservice.entity.*;
import cn.rankin.productservice.vo.CourseSubItemVo;
import org.springframework.beans.BeanUtils;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class DTOConverter {

    // ItemDTO to Item
    public static Item convert(ItemDTO itemDTO) {
        Item item = new Item();
        BeanUtils.copyProperties(itemDTO, item);

        return item;
    }

    // CourseDTO to Course
    public static Course convert(CourseDTO courseDTO) {
        Course course = new Course();
        BeanUtils.copyProperties(courseDTO, course);

        return course;
    }

    // WareDTO to Ware
    public static Ware convert(WareDTO wareDTO) {
        Ware ware = new Ware();
        BeanUtils.copyProperties(wareDTO, ware);
        return ware;
    }

    // SupportDTO to Support
    public static Support convert(SupportDTO supportDTO) {
        Support support = new Support();
        BeanUtils.copyProperties(supportDTO, support);
        return support;
    }

    // PriceDTO to Price
    public static ItemPrice convert(ItemPriceDTO itemPriceDTO) {
        ItemPrice itemPrice = new ItemPrice();
        BeanUtils.copyProperties(itemPriceDTO, itemPrice);
        return itemPrice;
    }

    // LessonDTO to Lesson
    public static Lesson convert(LessonDTO lessonDTO) {
        Lesson lesson = new Lesson();
        BeanUtils.copyProperties(lessonDTO, lesson);

        return lesson;
    }

    // Lesson to CourseSubItemVo
    public static CourseSubItemVo convert(Lesson lesson) {
        CourseSubItemVo subItemVo = new CourseSubItemVo();
        BeanUtils.copyProperties(lesson, subItemVo);
        subItemVo.setType(CourseSubTypeEnum.LESSON);

        return subItemVo;
    }

    // CourseSubRelationDTO convert CourseSubRelation
    public static CourseSubRelation convert(String courseId, CourseSubRelationDTO courseSubRelationDTO) {
        CourseSubRelation relation = new CourseSubRelation();
        relation.setCourseId(courseId);
        relation.setSubId(courseSubRelationDTO.getId());
        relation.setType(courseSubRelationDTO.getType());

        return relation;
    }

    public static Group convert(GroupDTO groupDTO) {
        Group group = new Group();
        BeanUtils.copyProperties(groupDTO, group);
        return group;
    }

    public static Tag convert(TagDTO tagDTO) {
        Tag tag = new Tag();
        BeanUtils.copyProperties(tagDTO, tag);
        return tag;
    }
}
